﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DockManager;
using System.IO;

namespace SaveLoadLayout
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        XamDockManager dockManager;
        int count = 1;
        string layoutContent;
        string fileName = @"c:\test.xml";

        public MainWindow()
        {
            InitializeComponent();
        }

        private void OnInitDM(object sender, RoutedEventArgs e)
        {
            InitDocManager();
            AddNewContentPane();
        }

        private void InitDocManager()
        {
            if (dockManager == null)
            {
                dockManager = CreateDockManager(0);
            }
        }

        private XamDockManager CreateDockManager(int rowNumber)
        {
            var dm = new XamDockManager();
            //CreateSplitTabPane();
            dm.Background = Brushes.Gray;
            dm.SetValue(Grid.RowProperty, rowNumber);
            gridEl.Children.Add(dm);
            return dm;
        }
        private void CreateSplitTabPane()
        {
            var tabPane = new TabGroupPane();
            var splitPane = new SplitPane();
            splitPane.Panes.Add(tabPane);
            dockManager.Panes.Add(splitPane);
        }

        private void AddNewContentPane()
        {
            string name = "Content" + count.ToString();
            count++;

            ContentPane cp = new ContentPane { Name = name, Header = name };
            var tabPane = new TabGroupPane();
            var splitPane = new SplitPane();
            tabPane.Items.Add(cp);
            splitPane.Panes.Add(tabPane);
            dockManager.Panes.Add(splitPane);
            //TabGroupPane tabPane = dockManager.Panes[0].Panes[0] as TabGroupPane;
            //tabPane.Items.Add(cp);
        }

        private void OnAddContent(object sender, RoutedEventArgs e)
        {
            AddNewContentPane();
        }

        private void ClearDockManager()
        {
            dockManager.Panes.Clear();
            gridEl.Children.Remove(dockManager);
            dockManager = null;
        }

        private void OnSaveLayout(object sender, RoutedEventArgs e)
        {
            //// Saving to current DM
            //layoutContent = dockManager.SaveLayout();

            // Saving to File option
            SaveToFile(fileName);
            ClearDockManager();
        }

        private void OnLoadLayout(object sender, RoutedEventArgs e)
        {
            InitDocManager();
            // Loading to other document manager.
            LoadFromFile(fileName);

            //dockManager.LoadLayout(layoutContent);
        }

        private void SaveToFile(string filePath)
        {
            using (Stream stream = new FileStream(filePath, FileMode.Create))
                dockManager.SaveLayout(stream);
        }

        private void LoadFromFile(string filePath)
        {
            if (File.Exists(filePath))
            {
                using (Stream stream = new FileStream(filePath, FileMode.Open))
                {
                    //var dm = CreateDockManager(1);
                    //dm.Background = Brushes.DarkGray;
                    //dm.LoadLayout(stream);

                    dockManager.LoadLayout(stream);
                }
            }
        }
    }
}
